100 CLEAR: REMark planets2_bas: AstronomiQL
110 WINDOW 512,256,0,0: k=7
120 g=6.67428E-11: au=1.496E8*1000: sc=256/au: timestep=24*3600: ct=0
130 DIM mass(9),px(9),py(9),vx(9),vy(9),forcex(9),forcey(9)
140 SCALE 2048/6,-1024/6/.75,-1024/6: CLS: main: REPeat r: loop
150 :
160 DEFine PROCedure attraction
170 sx=px(self): sy=py(self)
180 ox=px(other): oy=py(other)
190 dx=ox-sx: dy=oy-sy: d=SQRT(dx*dx+dy*dy)
200 IF d+1==1: d=1E-12
210 f=g*mass(self)*mass(other)/(d*d)
220 theta=atn2(dy,dx): fx=COS(theta)*f: fy=SIN(theta)*f
230 END DEFine attraction
240 :
250 DEFine PROCedure loop
260 FOR self=1 TO k
270 IF KEYROW(1)=8: GO TO 100
280 total_fx=0: total_fy=0
290   FOR other=1 TO k
300    REMark AT 1,1: PRINT self!!other!!
310    IF self=other: GO TO 330
320    attraction: total_fx=total_fx+fx: total_fy=total_fy+fy
330   END FOR other: forcex(self)=total_fx: forcey(self)=total_fy
340 END FOR self
350 FOR body=1 TO k
360  fx=forcex(body): fy=forcey(body): REMark AT 2,1: PRINT body!!
370  vx(body)=vx(body)+fx/mass(body)*timestep
380  vy(body)=vy(body)+fy/mass(body)*timestep
390  px(body)=px(body)+vx(body)*timestep
400  py(body)=py(body)+vy(body)*timestep
410  REMark AT body,1: PRINT px(body),py(body),
420 END FOR body: OVER 0: INK 7: FILL 1: CIRCLE 0,0,19: FILL 0: OVER -1
430 FOR j=1,2
440 FOR body=1 TO k
450  INK body-1: OVER -1: FILL 1: CIRCLE px(body)*sc*.75,py(body)*sc,5: FILL 0: OVER 0
460  POINT px(body)*sc*.75,py(body)*sc
470 END FOR body: PAUSE 2: END FOR j: ct=ct+1: IF ct=999: PAUSE 99: GO TO 100
480 END DEFine loop
490 :
500 DEFine PROCedure main
510 mass(1)=1.98892*1E30: px(1)=0: vy(1)=0: m=RND*50: p=.3: v=499
520 mass(7)=m*RND*1E21 : px(7)=(p+RND/2)*au: vy(7)=30*(999-RND(v))
530 mass(6)=m*RND*1E20 : px(6)=(p+RND/2)*au: vy(6)=30*(999-RND(v))
540 mass(5)=m*RND*1E19 : px(5)=(p+RND/2)*au: vy(5)=30*(999-RND(v))
550 mass(4)=m*RND*1E18 : px(4)=(p+RND/2)*au: vy(4)=30*(999-RND(v))
560 mass(3)=m*RND*1E17 : px(3)=(p+RND/2)*au: vy(3)=30*(999-RND(v))
570 mass(2)=m*RND*1E16 : px(2)=(p+RND/2)*au: vy(2)=30*(999-RND(v))
575 AT 0,0: PRINT 'MASS' : FOR i=1 TO 7: INK i: AT i+0,1: PRINT i!mass(i)
576 AT 8,0: PRINT 'DIST' : FOR i=1 TO 7: INK i: AT i+8,1: PRINT i!px(i)
577 AT 16,0:PRINT' SPEED': FOR i=1 TO 7: INK i: AT i+16,1: PRINT i!vy(i)
580 END DEFine main
590 ::
600 DEFine FuNction atn2(gg,dd)
610 REMark IF d+1==1: d=1E-10
620 IF dd<0 AND gg<0: aa=ATAN(gg/dd)-PI
630 IF dd=0 AND g<0: aa=-PI/2
640 IF dd>0: aa=ATAN(gg/dd)
650 IF dd<0 AND gg>=0: aa=ATAN(gg/dd)+PI
660 IF dd=0 AND gg>=0: aa=r1
670 RETurn aa: END DEFine
680 ::
